<?php

declare(strict_types=1);

namespace Plugin\cin_kbafinder_5;

require_once __DIR__.'/vendor/autoload.php';

use JTL\Plugin\Bootstrapper;

final class Bootstrap extends Bootstrapper
{
  public function installed(): void
  {
    $this->prepareColumnSettings();
  }

  public function enabled(): void
  {
  }

  public function disabled(): void
  {
  }

  public function updated($oldVersion, $newVersion): void
  {
    $this->prepareColumnSettings();
  }

  /**
   * erzeugt selected csv colmns.
   */
  private function prepareColumnSettings(): void
  {
    $columnSettingsFile = __DIR__.'/common/columns.json';
    if ( ! file_exists($columnSettingsFile)) {
      file_put_contents($columnSettingsFile, json_encode([
        'manufacturer' => true,
        'model' => true,
        'type' => true,
        'displacement' => true,
        'hp' => true,
        'kw' => true,
        'from' => true,
        'to' => true,
        'kbanumber' => true,
      ], \JSON_PRETTY_PRINT));
    }
  }
}
