<?php

declare(strict_types=1);

require_once __DIR__.'/../../../admin/includes/admininclude.php';
$oAccount->permission('PLUGIN_ADMIN_VIEW', true, true);

require \dirname(__DIR__, 1).'/src/warmup.php';

use Cin\KBAFinder5\TecDocCrawl;

$params = array_merge_recursive($_GET, $_POST);

header_remove();
header('Content-Type: application/json');

$response = new stdClass();
$response->status = 'success';
$response->message = '';
$response->data = new stdClass();

$providerIdFile = $P->getJTlPlugin()->getPaths()->getBasePath().'providerid';
$articleCountryFile = $P->getJTlPlugin()->getPaths()->getBasePath().'articlecountry';
$apikeyFile = $P->getJTlPlugin()->getPaths()->getBasePath().'apikey';

switch ($params['action']) {
  case 'read':
    $response->data->providerid = file_get_contents($providerIdFile);
    $response->data->articlecountry = file_get_contents($articleCountryFile);
    $response->data->apikey = file_get_contents($apikeyFile);

    break;
  case 'write':
    file_put_contents($providerIdFile, $params['providerid']);
    file_put_contents($articleCountryFile, $params['articlecountry']);
    file_put_contents($apikeyFile, $params['apikey']);
    $response->message = [
      'providerid' => 'Provider-ID wurde gespeichert.',
      'apikey' => 'API-Key wurde gespeichert.',
      'articlecountry' => 'Article Country wurde gespeichert.',
    ];

    break;
  case 'resetCrawlStore':
    TecDocCrawl::reset();
    $response->message = 'CrawlStore wurde zurückgesetzt.';

    break;
  default:
    $response->status = 'error';
    $response->message = 'Action "'.$params['action'].'" is not defined';
}
exit(json_encode($response, \JSON_ERROR_NONE));
