<?php

declare(strict_types=1);
require_once __DIR__.'/../../../admin/includes/admininclude.php';
require __DIR__.'/../src/warmup.php';

use Cin\KBAFinder5\Cron;

if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && 'xmlhttprequest' === mb_strtolower($_SERVER['HTTP_X_REQUESTED_WITH'])) {
  $oAccount->permission('PLUGIN_ADMIN_VIEW', true, true);
  $response = ['status' => 'success', 'data' => null, 'message' => null];
  $params = array_merge($_GET, $_POST);
  $cron = new Cron();
  switch ($params['action']) {
    case 'status':
      $response['data'] = [
        'status' => $cron->status(),
      ];

      break;

    case 'install':
      $cron->install()->pause();
      $response['data'] = [
        'status' => $cron->status(),
      ];

      break;

    case 'start':
      $cron->run();
      $response['data'] = [
        'status' => $cron->status(),
      ];

      break;

    case 'stop':
      $cron->pause();
      $response['data'] = [
        'status' => $cron->status(),
      ];

      break;

    case 'uninstall':
      $cron->uninstall();
      $response['data'] = [
        'status' => $cron->status(),
      ];

      break;

    default:
      $response['status'] = 'warn';
      $response['message'] = "action '{$params['action']}' is not defined";

      break;
  }
  header('Content-Type: application/json');
  exit(json_encode($response, 512));
}

$smarty->assign('serviceURL', $P->getJTlPlugin()->getPaths()->getAdminURL());
$smarty->assign('cronURL', URL_SHOP.'/plugins/cin_kbafinder_5/cron.php');
$smarty->display(__DIR__.'/template/service.tpl');
