<?php

declare(strict_types=1);

ini_set('html_errors', 'false');
ini_set('max_execution_time', '0');
date_default_timezone_set('Europe/Berlin');

header('Content-Type: text/plain');

$lock = fopen(__DIR__.'/cron.lock', 'cb');
if ( ! flock($lock, \LOCK_EX | \LOCK_NB)) {
  out('could not get exclusive lock');
  out('==> termintating');
  exit(-1);
}

function out($message): void
{
  $now = date('c');
  echo $now.' '.$message."\n";
}

require_once __DIR__.'/src/warmup.php';

include __DIR__.'/src/cron_crawl_tecdoc.inc.php';
include __DIR__.'/src/cron_normalize_kbanrs.inc.php';

flock($lock, \LOCK_UN);
