<?php

declare(strict_types=1);
require __DIR__.'/../../src/warmup.php';

if ( ! $L->canRun()) {
  return;
}

$articleCounts = [];
if ( ! \function_exists('cin_dropEmptyCategories')) {
  function cin_dropEmptyCategories(&$categories, $articleCounts, $parent = null): int
  {
    $total = 0;
    foreach ($categories as &$category) {
      $cnt = $articleCounts[$category->getID()];
      if ($category->hasChildren()) {
        $children = $category->getChildren();
        $cnt += cin_dropEmptyCategories($children, $articleCounts, $category);
      }
      if (0 === $cnt) {
        unset($categories[$category->getID()]);
        if (null !== $parent) {
          $parent->setChildren($categories);
        }
      }
      $total += $cnt;
    }

    return $total;
  }
}

if (isset($_COOKIE['cin_kbafinder']) && null !== json_decode($_COOKIE['cin_kbafinder'])->current && null !== json_decode($_COOKIE['cin_kbafinder'])->current->kba) {
  $kbanummer = json_decode($_COOKIE['cin_kbafinder'])->current->kba;
  $params = [
    ':kbanr' => $kbanummer,
    ':kkundengruppe' => $_SESSION['Kundengruppe']->kKundengruppe,
  ];
  $sql = 'SELECT tkategorie.kKategorie AS cat,
  (SELECT COUNT(tartikel.kArtikel) FROM tartikel
  LEFT JOIN xplugin_cin_kbafinder_helper ON tartikel.kArtikel = xplugin_cin_kbafinder_helper.kartikel
  LEFT JOIN tkategorieartikel ON tartikel.kArtikel = tkategorieartikel.kArtikel
  WHERE tartikel.kArtikel NOT IN (SELECT kArtikel FROM tartikelsichtbarkeit WHERE kKundengruppe = :kkundengruppe) AND
      tkategorieartikel.kKategorie = cat AND
      (xplugin_cin_kbafinder_helper.kbanr = :kbanr OR xplugin_cin_kbafinder_helper.kartikel IS NULL)
  ) AS cnt
  FROM tkategorie';
  if ($partitioned) {
    $pidx = mb_substr($kbanummer, 0, 2);
    $params[':pidx'] = $pidx;
    $sql = 'SELECT tkategorie.kKategorie AS cat,
    (SELECT COUNT(tartikel.kArtikel) FROM tartikel
    LEFT JOIN xplugin_cin_kbafinder_helper ON tartikel.kArtikel = xplugin_cin_kbafinder_helper.kartikel
    LEFT JOIN tkategorieartikel ON tartikel.kArtikel = tkategorieartikel.kArtikel
    WHERE tartikel.kArtikel NOT IN (SELECT kArtikel FROM tartikelsichtbarkeit WHERE kKundengruppe = :kkundengruppe) AND
        tkategorieartikel.kKategorie = cat AND xplugin_cin_kbafinder_helper.pidx = :pidx AND
        (xplugin_cin_kbafinder_helper.kbanr = :kbanr OR xplugin_cin_kbafinder_helper.kartikel IS NULL)
    ) AS cnt
    FROM tkategorie';
  }

  $articleCountRows = $P->getPDO()->prepare($sql);
  $articleCountRows->execute($params);
  foreach ($articleCountRows->fetchAll(PDO::FETCH_ASSOC) as $row) {
    $articleCounts[$row['cat']] = (int) ($row['cnt']);
  }
  cin_dropEmptyCategories($args_arr['categories'], $articleCounts);
  $_SESSION['cin_kbafinder_categories_filtered'] = true;
}
