<?php

declare(strict_types=1);

namespace Cin\KBAFinder5;

final class Cron
{
  public function buildCronLine()
  {
    $when = '* * * * *';
    $curl = $this->getCurlCmd();
    $host = URL_SHOP;
    $path = '/plugins/cin_kbafinder_5/cron.php';
    $log = \dirname(__DIR__).'/cron.log';

    return $when.' '.$curl.' '.$host.$path.' >> '.$log;
  }

  public function isInstalled()
  {
    return Crontab::doesJobExist($this->buildCronLine());

    return $this;
  }

  public function install()
  {
    $this->clean();
    Crontab::addJob($this->buildCronLine());

    return $this;
  }

  public function uninstall()
  {
    $this->clean();

    return $this;
  }

  public function pause()
  {
    $this->clean();
    Crontab::addJob('# '.$this->buildCronLine());

    return $this;
  }

  public function run()
  {
    $this->clean();
    Crontab::addJob($this->buildCronLine());

    return $this;
  }

  public function status()
  {
    if ( ! Crontab::doesJobExist($this->buildCronLine())
    && ! Crontab::doesJobExist('# '.$this->buildCronLine())) {
      return 'uninstalled';
    }
    if (Crontab::doesJobExist($this->buildCronLine())) {
      return 'running';
    }
    if (Crontab::doesJobExist('# '.$this->buildCronLine())) {
      return 'paused';
    }
  }

  private function clean(): void
  {
    Crontab::removeJob($this->buildCronLine());
    Crontab::removeJob('# '.$this->buildCronLine());
  }

  private function getCurlCmd()
  {
    return exec('which curl').' '.'-s';
  }
}
