<?php

declare(strict_types=1);

namespace Cin\KBAFinder5;

final class Crontab
{
  public static function getJobs()
  {
    $output = shell_exec('crontab -l');

    return self::stringToArray($output);
  }

  public static function saveJobs($jobs = [])
  {
    return shell_exec('echo "'.self::arrayToString($jobs).'" | crontab -');
  }

  public static function doesJobExist($job = '')
  {
    $jobs = self::getJobs();

    return (bool) (\in_array($job, $jobs, true));
  }

  public static function addJob($job = '')
  {
    if (self::doesJobExist($job)) {
      return false;
    }
    $jobs   = self::getJobs();
    $jobs[] = $job;

    return self::saveJobs($jobs);
  }

  public static function removeJob($job = '')
  {
    if (self::doesJobExist($job)) {
      $jobs = self::getJobs();
      unset($jobs[array_search($job, $jobs, true)]);

      return self::saveJobs($jobs);
    }

    return false;
  }

  private static function stringToArray($jobs = '')
  {
    $array = explode("\n", trim($jobs));
    foreach ($array as $key => $item) {
      if ('' === $item) {
        unset($array[$key]);
      }
    }

    return $array;
  }

  private static function arrayToString($jobs = [])
  {
    return implode("\n", $jobs);
  }
}
