<?php

declare(strict_types=1);

if ( ! \function_exists('smarty_function_findlabel')) {
  function smarty_function_findlabel($params, &$smarty): string
  {
    $lang    = $smarty->getTemplateVars()['lang'];
    $columns = $smarty->getTemplateVars()['columns'];
    $label   = '&nbsp;';

    if ($columns['type']) {
      $label = $lang['cin_kbafinder_type'];
    } elseif ($columns['displacement'] || $columns['hp'] || $columns['kw']) {
      $label = $lang['cin_kbafinder_ouput'];
    } elseif ($columns['from'] || $columns['to']) {
      $label = $lang['cin_kbafinder_year'];
    } else {
      $label = $lang['cin_kbafinder_keynumber'];
    }

    return $label;
  }
}
